require 'config_core/version'
require 'config_core/scopes_collection'
require 'config_core/scope'
require 'config_core/parameter'

module ConfigCore
  class ScopeAlreadyExistsError < StandardError; end
  class ParameterAlreadyExistsError < StandardError; end
  class TryingToModifyUneditableParameterError < StandardError; end

  def self.extended(klass)
    klass.instance_variable_set(:@config_scopes_collection, ScopesCollection.new)
  end

  def scopes
    @config_scopes_collection
  end

  alias config scopes
end
