module ConfigCore
  class Parameter
    attr_reader :name, :value, :default_value

    def initialize(name, value)
      @name = name
      @default_value = value
      
      begin
        @value = value.dup
      rescue TypeError
        @value = value
      end

      @editable = true
    end

    def disable_editing!
      @editable = false
      @value.freeze
    end

    def editable?
      @editable
    end

    def value=(value)
      raise TryingToModifyUneditableParameterError unless editable?

      @value = value
    end
  end
end
