module ConfigCore
  class ScopesCollection
    def initialize
      @scopes = {}
    end

    def to_h
      @scopes
    end

    def [](name)
      @scopes[name]
    end

    def has_scope?(name)
      @scopes.has_key?(name)
    end

    def define(name)
      raise ScopeAlreadyExistsError if has_scope?(name)

      scope = Scope.new(name)
      yield(scope) if block_given?
      @scopes[name] = scope

      define_scope_reader(name, scope)

      return scope
    end

    private
    def define_scope_reader(name, scope)
      define_singleton_method(name) { scope }
    end
  end
end
